# -*- coding: UTF-8 -*-
import logging
import logging.config
from logging.handlers import RotatingFileHandler
import os
import sys

path = os.path.dirname(os.path.abspath(__file__))
configFilePath = os.path.join(path, "logger.config.ini")
logging.config.fileConfig(configFilePath)
#print format
format = "[%(asctime)-15s]-[%(levelname)s]-[%(funcName)s]-[%(lineno)d]:[%(message)s]"
dateformat = "%a %d %b %Y %H:%M:%S"


#返回默认路径logger
def getLogger():
        logger = logging.getLogger('root')
        currPath = os.path.dirname(os.path.abspath(__file__))
        path =os.path.join(currPath, "..\\")
        logpath = os.path.join(path, "..\\log\\InfoGrab_Python.log")
        rtHandler =  RotatingFileHandler(logpath, 'a', maxBytes=20*1024*1024,backupCount=5)
        formatter = logging.Formatter(format, dateformat)
        rtHandler.setFormatter(formatter)
        logger.addHandler(rtHandler)
        return logger  