#coding:utf-8
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
sys.path.append(path)
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import * 
from host_wwpn import getAllHbaObjs



def execute(context):
    '''
    @summary:脚本入口
    @param context:上下文
    @return:处理过后的上下文
    '''
    hbaObjs = getAllHbaObjs(context)
    result  = getAllHbaFwVersions(hbaObjs)
    context.put('result',result)
    return context



def getAllHbaFwVersions(hbas):
    '''
    @summary: 获取hp主机fw版本
    @hbas:hba卡驱动版本和固件版本回文
    @return :fw版本
    '''
    drVersions = ''
    for hba in hbas:
        if 'ONLINE'.lower()  != hba.getState().lower() :
            continue
        drVersions = drVersions +';'+ hba.getFwVersion()
    if not drVersions:
        drVersions = 'NA'
    else:
        drVersions = drVersions[1:]
    return drVersions
