# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context
global vg_lst_value_lst
global lv_lst_value_lst

#对应excel中的属性字段
key_lst = ["vg_name","vg_size","lv_name","lv_size","lv_status"]

#获取Linux主机集群 lvm /vxvm信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    vg_lst_value_lst = []
    lv_lst_value_lst= []
    #获取vg，lv 信息所对应回文的列表
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                if key_lst[0] in attr.lower():
                    #获得vg name　lst
                    vg_lst_value_lst =  getValueFMap(attr_valuelst_dic, style, attr)
                if key_lst[2] in attr.lower():
                    #获得lv lst
                    lv_lst_value_lst = getValueFMap(attr_valuelst_dic, style, attr)

    vg_lst = get_vg_lst(vg_lst_value_lst)
    lv_lst = get_lv_lst(lv_lst_value_lst)        
    for lvObj in lv_lst:
        for vgObj in vg_lst:
            if lvObj.get_vgname() == vgObj.get_vgname():
                lvObj.set_vgsize(vgObj.get_vgsize())
    
    for result in lv_lst:
        value_lst.append(result.get_vgname())
        value_lst.append(result.get_vgsize())
        value_lst.append(result.get_lvname())
        value_lst.append(result.get_lvsize())
        value_lst.append(result.get_lvstatus())
        
    #获取json结果字符串 
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)
 

#功能说明：返回vg对象列表
def get_vg_lst(tempList):
    objList = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        vgObj = vg_Entity()
        objList.append(vgObj)
        return objList
    
    for line in tempList:
        if failStr.lower() in line.lower():
            vgObj = vg_Entity()
            objList.append(vgObj)
            return objList
        
    for line in tempList:
        if ('vg' in line.lower()) and ('name' in line.lower()):
            vgObj = vg_Entity()
            result = line.lower()
            result = result.split(' ')[-1].strip()
            vgObj.set_vgname(result)
        if ('vg' in line.lower()) and ('size' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-2].strip()
            vgObj.set_vgsize(result+'GB')
            objList.append(vgObj)
    return objList


#功能说明：返回lv对象列表
#lv name:"", lv size:"", lv status:"",vg name: "",lv vgname:""
def get_lv_lst(tempList):
    objList = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        lvmObj = Lvm_Entity()
        objList.append(lvmObj)
        return objList
    
    for line in tempList:
        if failStr.lower() in line.lower():
            lvmObj = Lvm_Entity()
            objList.append(lvmObj)
            return objList
    
        
    for line in tempList:
        if ('lv' in line.lower()) and ('name' in line.lower()):
            lvmObj = Lvm_Entity()
            result = line.lower()
            result = result.split(' ')[-1].strip()
            lvmObj.set_lvname(result)
        elif ('vg' in line.lower()) and ('name' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-1].strip()
            lvmObj.set_vgname(result)
        elif ('lv' in line.lower()) and ('status' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-1].strip()
            lvmObj.set_lvstatus(result)
        elif ('lv' in line.lower()) and ('size' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-2].strip()
            if 'mb' in line.lower():
                lvmObj.set_lvsize(result+'MB')
            elif 'gb' in line.lower():
                lvmObj.set_lvsize(result+'GB')
            objList.append(lvmObj)
    return objList

 
def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    else:
        return "Key Error"

class Lvm_Entity:
    __vgname = 'NA'
    __vgsize = 'NA'
    __lvname = 'NA'
    __lvsize = 'NA'
    __lvstatus = 'NA'
    def get_vgname(self):
        return self.__vgname
    def get_vgsize(self):
        return self.__vgsize
    def get_lvname(self):
        return self.__lvname
    def get_lvsize(self):
        return self.__lvsize
    def get_lvstatus(self):
        return self.__lvstatus
    def set_vgname(self,vgname):
        self.__vgname = vgname
    def set_vgsize(self,vgsize):
        self.__vgsize = vgsize
    def set_lvname(self,lvname):
        self.__lvname = lvname
    def set_lvsize(self,lvsize):
        self.__lvsize = lvsize
    def set_lvstatus(self,lvstatus):
        self.__lvstatus  = lvstatus

class vg_Entity:
    __vgname = 'NA'
    __vgsize = 'NA'
    
    def get_vgname(self):
        return self.__vgname
    def get_vgsize(self):
        return self.__vgsize
    def set_vgname(self,vgname):
        self.__vgname = vgname
    def set_vgsize(self,vgsize):
        self.__vgsize = vgsize
        

def get_value_bykey(tempList,key):
     if key == key_lst[0]:
         return get_servermodel(tempList)
     else:
         return "Key Error"
