# --*-- coding:utf-8 --*--
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import getSameCommandsHbaRetFromTxt,check_lst

CMD_DESC_STATE = "cmd_display_hba_card_status"
CMD_DESC_WWPN = "cmd_display_hba_card_port_name_cat"

def execute(context):
    '''
    @summary: 脚本入口
    @param context:上下文
    @return context:处理后的上下文
    '''
    
    states = []
    wwpns = []
    
    state_lst = getSameCommandsHbaRetFromTxt(context,[CMD_DESC_STATE])[0]
    wwpn_lst = getSameCommandsHbaRetFromTxt(context,[CMD_DESC_WWPN])[0]
    state_lst = check_lst(state_lst)
    wwpn_lst = check_lst(wwpn_lst)
    for line in wwpn_lst:
        if line.strip().startswith("0x"):
            wwpns.append(line.strip())
    
    for line in state_lst:
        if ('linkdown' in line.lower()) or ('online' in line.lower()):
            states.append(line.strip())
    
    result = checkWwpnResult(states,wwpns)
    context.put("result", result)
    return context

def checkWwpnResult(states, wwpns):
    '''
    @summary: 过滤掉状态不为online的wwpn
    @param status: 状态组成的列表
    @param wwpns:wwpn组成的列表
    @return result: 过滤后的wwpn
    '''
    result = ""

    if len(states) != 0:
        for i, stateValue in enumerate(states):
            if 'online' in stateValue.lower():
                result = result + wwpns[i][2:] + ';'
    if len(result) > 0:
        if ';' == result[-1]:
            result = result[0:-1]
    return result

