# --*-- coding:utf-8 --*--
import sys 
import os
import re
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context


#对应excel中的属性字段
key_lst  = [
                "tablespace_name",
                "datafile_name",
                "capacity"
           ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #检查key_lst
    check_keylst(key_lst,attribute_arr)
    tb_spacenameobj_lst = []
    #tablespace_name  ,capacity
    tablespace_name_lst = attr_valuelst_dic[attribute_arr[0]]
    tb_spacenameobj_lst = get_tbspaceobj_lst(tablespace_name_lst)
    #datafile_name
    namecap_lst = attr_valuelst_dic[attribute_arr[1]]
    dfnametemp_lst =[]
    for nline in namecap_lst:
        if (("tablespace" in nline.lower()) and ("name" in nline.lower())):
            continue
        if (("file" in nline.lower()) and ("name" in nline.lower())):
            continue
        if ('---' in nline.lower()):
            continue
        if ('bytes' in nline.lower()):
            continue
        if "" != nline.strip():
            dfnametemp_lst.append(nline)
    
    namecap_lst = dfnametemp_lst
    for tbobj in tb_spacenameobj_lst:
        for j,line_value in enumerate(namecap_lst):
            if tbobj.get_tsname().lower() in line_value.lower():
                filename = namecap_lst[j+1].strip()
                tbobj.set_dfname(filename)
                break
                
    for tb in tb_spacenameobj_lst:
        value_lst.append(tb.get_tsname())
        value_lst.append(tb.get_dfname())
        value_lst.append(tb.get_capacity())
        
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)

    return context
#功能说明：返回tablespace_name cap
def get_tbspaceobj_lst(templst):
    value_lst = []
    obj_lst = []
    result = 'NA'
    if 0 == len(templst):
        tempobj = Tablespace_Name()
        obj_lst.append(tempobj)
        return obj_lst
    if not is_success(templst):
        tempobj = Tablespace_Name()
        obj_lst.append(tempobj)
        return obj_lst
    
    for i,line in enumerate(templst):
        if "****" in line:
            continue
        if (("tablespace" in line.lower()) and ("name" in line.lower())):
            continue
        if "file_name" in line.lower():
            continue
        if "bytes" in line.lower():
            continue
        
        if "" != line.strip():
            value_lst.append(line)
    
        
    for i,line in enumerate(value_lst):
        if '---' in line:
            value_lst = value_lst[i+1:]
            break
    
    for line in value_lst:
        lst = re.split('\\s+',line)
        if len(lst) == 2:
            tbspace_name = lst[0].strip()
            tbspace_obj = Tablespace_Name()
            tbspace_obj.set_tsname(tbspace_name)
            cap = lst[1].strip()
            try:
                if cap[0]=='.':
                    cap = '0'+cap
                if float(cap)>1.0:
                    if float(cap)>102.0:
                        #大于102MB才转化为GB
                        cap = str(round(float(cap)/1024.0,2))+' GB'
                    else:
                        cap = str(cap)+' MB'
                else:
                    cap = str(cap) + ' MB'
            except:
                pass
            
            tbspace_obj.set_capacity(cap)
            obj_lst.append(tbspace_obj)
    if 0 == len(obj_lst):
        tbname = Tablespace_Name()
        obj_lst.append(tbname)
        return obj_lst
    return obj_lst

#功能说明：返回检查key_lst
def check_keylst(key_lst,attribute_arr):
    if not (len(key_lst) == len(attribute_arr)):
        raise Exception("key lst Error")


#功能说明：返回属性名与回文列表组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

class Tablespace_Name:
    __ts_name = 'NA'
    __datafile_name = 'NA'
    __capacity = 'NA'
    def set_tsname(self,tsname):
        self.__ts_name = tsname
    def set_dfname(self,dfname):
        self.__datafile_name = dfname
    def set_capacity(self,cap):
        self.__capacity = cap
    def get_tsname(self):
        return self.__ts_name
    def get_dfname(self):
        return self.__datafile_name
    def get_capacity(self):
        return self.__capacity
