# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst = ["server_model","cpu_model","memory","os","multipath","cluster","lvm/vxvm","database"]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                value = get_value_bykey(tempList,key)
                value_lst.append(value)
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回lvm/Vxvm
def get_LVM_VxVM(lvm_lst):
    #cmd_display_logic_volume_lvm  有回显为LVM
    #cmd_display_logic_volume_rpm_vxvm 有回显为VxVM
    result = "NA"
    lvxm_block_lst = get_block_lst(lvm_lst)
    #lvm lst
    lvmtemp_lst = []
    for lst in lvxm_block_lst:
        lst_temp = ';'.join(lst)
        if 'cmd_display_logic_volume_lvm' in lst_temp:
            lvmtemp_lst.append(lst)
    #vxvm lst
    vxvmtemp_lst = []
    for lst in lvxm_block_lst:
        lst_temp = ';'.join(lst)
        if 'cmd_display_logic_volume_rpm_vxvm' in lst_temp:
            vxvmtemp_lst.append(lst)
    #LVM
    for lvmlst in lvmtemp_lst:
        if is_success(lvmlst):
            result = "LVM"
            break
    #VxVM
    for vxlst in vxvmtemp_lst:
        if is_success(vxlst):
            result = "VxVM"
            break
    return result
    
#功能说明：返回集群名称
def get_clusternames(cluster_lst):
    cluster_block_lst = get_block_lst(cluster_lst)
    #PaceMaker lst
    pacemaker_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_crmadmin' in lst_temp) or ('cmd_display_cluster_classes' in lst_temp) or ('cmd_display_cluster_crm_mon' in lst_temp):
            pacemaker_lst.append(lst)
    #RHCS lst
    rhcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon,cmd_display_cluster_clustat
        if ('cmd_display_cluster_RHCS' in lst_temp) or ('cmd_display_cluster_clustat' in lst_temp):
            rhcs_lst.append(lst)
    #VCS lst
    vcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_VRTSvcs' in lst_temp) or ('cmd_display_storage_foundation_hastatus_sum' in lst_temp):
            vcs_lst.append(lst)
    
    rac_lst = []
    rac_statuslst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        if ('cmd_display_cluster_findrac' in lst_temp.lower()):
            rac_lst.append(lst)
        if ('cmd_display_cluster_racstat' in lst_temp.lower()):
            rac_statuslst.append(lst)
    #RAC obj 
    has_racone = False
    has_racsec = False
    has_rac = False
    if 0 != len(rac_lst):
        if (len(rac_lst[0]) > 2):
            rac_result_lst = rac_lst[0]
            for line in rac_result_lst[2:-1]:
                if ('crs_stat' in line):
                    has_racone = True
                    break
    if 0 != len(rac_statuslst):
        has_racsec = True
        
    #状态回文
    has_rac = has_racone and has_racsec
    rac_obj = Cluster_Info()
    if has_rac:
        rac_obj.set_name('RAC')
     
    #PaceMaker obj
    pacemaker_obj = Cluster_Info()
    has_pace = False
    has_pace = has_cluster(pacemaker_lst)
    
    if has_pace:
        pacemaker_obj.set_name('NA')
        
    #RHCS obj
    rhcs_obj = Cluster_Info()
    has_rhcs = False 
    has_rhcs = has_cluster(rhcs_lst)

    if has_rhcs:
        rhcs_obj.set_name('RHCS')
        
    #VCS obj
    vcs_obj = Cluster_Info()
    has_vcs =  False
    has_vcs = has_cluster(vcs_lst)
    
    if has_vcs:
        vcs_obj.set_name('NA')
        
    #cluster obj 集合
    cluster_obj_lst = []
    if rac_obj.get_name() != 'NA':
        cluster_obj_lst.append(rac_obj)
    if pacemaker_obj.get_name() != 'NA':
        cluster_obj_lst.append(pacemaker_obj)
    if rhcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(rhcs_obj)
    if vcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(vcs_obj)
    
    
    cluster_value = ""
    for cluster in cluster_obj_lst:
        cluster_value = cluster_value + cluster.get_name() +','
    cluster_value = cluster_value[0:-1]
    if "" == cluster_value.strip():
        return "NA"
    else:
        return cluster_value
    

#功能说明：返回单个命令回文列表组成的列表
def get_block_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList

#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

 
#功能说明：返回Server model
def get_servermodel(tempList):
    result = 'NA'
    if not is_success(tempList):
        return result
    length = len(tempList)
    index = 0 
    for i in range(length):
        if "uname -a" in tempList[i]:
            index = i +1
            break
    result = tempList[index]
    ret_lst = re.split(' ',result)
    if (len(ret_lst)>2):
        result = ret_lst[0]+' '+ret_lst[1] +' '+ret_lst[2] 
    
    return result

#功能说明：返回CPU model    
def get_cpumodel(tempList):
    #架构 厂商，位数。如：x86-64 AMD64
    arch = 'NA'
    vendor = 'NA'
    osbit = 'NA'
    
    if 0==len(tempList):
        return 'NA'
    result = ""
    for i,line in enumerate(tempList):
        if 'arch' in line.lower():
            if 'x86_64' in tempList[i+1].lower():
                osbit = '64'
                arch = tempList[i+1].strip()
            else:
                osbit = '32'
                arch = tempList[i+1].strip()
    for line in tempList:
        if ('vendor' in line.lower()) and ('id' in line.lower()):
            vendor = line.split(':')[-1].strip()
            break
    result = arch+' '+vendor+osbit
    return result 

#功能说明：返回Memory
def get_memory(tempList):
    if 0==len(tempList):
        return 'NA'
    
    result = ""
    tempStr = ""
    for i in range(len(tempList)):
        if "MemTotal" in tempList[i].strip():
            tempStr = tempList[i]
    total_mem = tempStr.replace(':', ' ').replace('MemTotal', ' ').strip()
    try:
        total = '' + str(round(float(total_mem.replace("kB", '')) / 1024 / 1024, 2)) + "GB"
    except:
        total = 'NA'
    result = total
    if '' ==result.strip():
        result ="NA"
    return result 

#功能说明：返回Multipath name
def get_multipath(mulBlock_lst):
    failStr = "TOOLKIT_EXE_CMD_FAILED"
    block_lst = []
    mulobj_lst = []
    multipaths = ""
    #过滤掉失败的段
    for block in mulBlock_lst:
        if  is_success(block):
            block_lst.append(block)
            
    for block in block_lst:
        mulObj = Multipath_Entity()
        for j,line in enumerate(block):
            #PowerPath
            if ('powermt' in line.lower())and ('version' in line.lower()) :
                mulObj.set_name('PowerPath')
                break
            #UltraPath
            elif ('upadmin' in line.lower()) and ('show' in line.lower()):
                mulObj.set_name('UltraPath')
                #UltraPath version
                for vline in block[j:]:
                    if ('version' in vline.lower()) and ('software' in vline.lower()):
                        tempArr = re.split('\\s+', vline)
                        mulObj.set_version(tempArr[3])
                        break
                break
            #HDLM
            elif 'dlnkmgr' in line:
                mulObj.set_name('HDLM')
                break
            #UltraPath
            elif ('upadm' in line.lower()) and ('show' in line.lower()):
                mulObj.set_name('UltraPath')
                break
            #Multipath
            elif ('multipath' in line.lower()) and ('ll' in line.lower()):
                mulObj.set_name('Multipath')
                break
            else:
                pass
        mulobj_lst.append(mulObj)
    
    for mul in mulobj_lst:
        if 'NA'!= mul.get_name():
            multipaths = multipaths + mul.get_name() +','
    multipaths = multipaths[0:-1]
    if "" == multipaths:
        multipaths = 'NA'
    return multipaths
 

#功能说明：返回database
def get_database(tempList):
    result = "NA"
    index=0
    if 0 == len(tempList):
        return result
    for i in range(len(tempList)):
        if "Enterprise Edition" in tempList[i]:
            index=i
            break
    if 0 == index:
        return result
    try:
        result=tempList[index].strip()
    except:
        pass
    return result 


#功能说明：返回OS
def get_os(tempList):
    if 0==len(tempList):
        return 'NA'
    
    result = ""
    op_sys_info=""
    dev_type=""
    for t in range(len(tempList)):
        op_sys_info=op_sys_info+tempList[t]+'\n'

    tem_line = op_sys_info.splitlines()
    if 'Asianux' in op_sys_info:
        for i in range(0, len(tem_line)):
            #####################     Suse Area    #####################
            if 'Asianux' in tem_line[i]:
                dev_type = 'Asianux ' + tem_line[i].split()[2]
                break
    elif 'Debian' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Debian' in tem_line[i]:
                dev_type = 'Debian ' + tem_line[i].split()[2]
                break
    elif 'Oracle Linux' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Oracle Linux' in tem_line[i]:
                dev_type = 'Oracle Linux ' + tem_line[i].split()[4]
                break
    elif 'SUSE' in op_sys_info:        
        for i in range(0,len(tem_line)):
            if 'VERSION' in tem_line[i]:
                version = tem_line[i].split('=')[1].strip()
                dev_type = 'SUSE '+version
            if 'PATCHLEVEL' in tem_line[i]:
                level = tem_line[i].split('=')[1].strip()
                dev_type = dev_type + ' ' + 'SP' + level
                break
    #####################   Red Hat Area    #####################
    elif 'Red Hat' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Red Hat' in tem_line[i] and "=" not in tem_line[i]:
                dev_type = "Red Hat " + tem_line[i].split()[6]
                break
    #####################   CentOS Area    #####################
    elif 'CentOS' in op_sys_info: 
        for i in range(0, len(tem_line)):
            if 'CentOS' in tem_line[i]:
                dev_type = "CentOS " + tem_line[i].split()[2]
                if dev_type == 'CentOS release':
                    dev_type = "CentOS " + tem_line[i].split()[3]
                break
    #####################   XenServer Area    #####################
    elif 'XenServer' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'XenServer' in tem_line[i]:
                dev_type = "XenServer " + tem_line[i].split()[3];
                break
            #####################   Ubuntu Area    #####################
    elif 'Ubuntu' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Ubuntu' in tem_line[i]:
                dev_type = ""
                resultList=tem_line[i].split()
                dev_type = resultList[0]+resultList[1]
                break
    result=dev_type
    if ""==result.strip():
        result = "not found"
    return result


#功能说明：返回单个命令回文列表组成的列表
def get_eachmulti_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList


def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    elif key == key_lst[1]:
        return get_cpumodel(tempList)
    elif key == key_lst[2]:
        return get_memory(tempList)
    elif key == key_lst[3]:
        return get_os(tempList)
    elif key == key_lst[4]:
        txtblock_lst = get_eachmulti_lst(tempList)
        multipaths = get_multipath(txtblock_lst)
        return multipaths
    elif key == key_lst[5]:
        return get_clusternames(tempList)
    elif key == key_lst[6]:
        return get_LVM_VxVM(tempList)
    elif key == key_lst[7]:
        return get_database(tempList)
    else:
        return "Key Error"

class Cluster_Info:
    __name = 'NA'
    __version = 'NA'
    __status = 'NA'
    def set_name(self,name):
        self.__name = name
    def set_version(self,ver):
        self.__version = ver
    def set_status(self,status):
        self.__status = status
    def get_name(self):
        return self.__name
    def get_version(self):
        return self.__version
    def get_status(self):
        return self.__status
    
class Multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self,name):
        self.__mul_name = name
    def set_version(self,version):
        self.__mul_version = version
    def set_status(self,status):
        self.__mul_status = status
