# coding=utf-8
__author__ = '******'
# vmware虚拟机信息
import os
import re
import sys
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common.contentParse import getCommandRet

cmd_info_id = [
               "cmd_info_virtual_machine_vms"          
               ]
            
cmd_info_desc = [
                 "vim-cmd vmsvc/getallvms"
                 ]

cmd_desc = "vim-cmd vmsvc/getallvms"
singleVim_cmd_id = "cmd_info_virtual_single_info_"
singleVim_cmd_desc = "vim-cmd vmsvc/get.summary "

def execute(context):
    
    CLI = context.get("SSH")
    
    vmidsList = get_cmdlst_allVms(CLI, cmd_desc)
    
    if None != vmidsList:
        for vmid in vmidsList:
            cmd_info_id.append(singleVim_cmd_id + vmid)
            cmd_info_desc.append(singleVim_cmd_desc + vmid)
    
    return getCommandRet(context, cmd_info_id, cmd_info_desc)

def get_cmdlst_allVms(CLI, cmd_desc):
    cmd_value_temp = CLI.execCmd(cmd_desc)
    cmd_value_lst = cmd_value_temp.splitlines()
    #过滤掉无用的数据
    check_lst = []
    for line in cmd_value_lst:
        if '' != line.strip():
            check_lst.append(line)
    cmd_value_lst = check_lst

    vmids_lst = []
    for line in cmd_value_lst:
        lineList = re.split('\s\s+', line)
        if 2 < len(lineList):
            strFirst = lineList[0]
            if(strFirst.isdigit()):
                vmids_lst.append(strFirst)
    
    return vmids_lst 
