# --*-- coding:utf-8 --*--


#获取主机内存使用量


fileList=None


def execute(context):
    global fileList
    command=""
    pathstr=""
    tempList=[]
    result=""
    
    command = context.get("command")
    commandList=command.split(',')
    pathstr = context.get("path")
    fileList=getTxtReportList(pathstr);
    
    for i in range(len(commandList)):
        dict = getCommandStartEndIndex(commandList[i])
        startIndex = dict["start"]
        endIndex = dict["end"]
        tempList =tempList + fileList[startIndex:endIndex + 1]
    result = extractInfo(tempList)
    context.put("result",result)
    return context


#处理关键信息列表提取字段
def extractInfo(tempList):
    result=""
    temp=""
    count=0
    count2=0
    totalMem=0
    freeMem=0
    useMem=0
    for i in range(len(tempList)):
        if "Physical Mem" in tempList[i] or "PhysicalMem" in tempList[i]:
            temp=tempList[i]
            break
    for j in range(len(temp)):
        if "." == temp[j]:
            count=count+1
    
    temp=temp.replace(".","",count)
    temp=temp.replace("Physical", "")
    temp=temp.replace("Mem","")
    temp=temp.replace("|----","").strip()
    temp=temp.replace("bytes","").strip()
    totalMem=int(temp)
    
    #free
    for m in range(len(tempList)):
        if "Free" in tempList[m] and "kilobytes" in tempList[m]:
            temp=tempList[m]
            break
    for n in range(len(temp)):
        if "." == temp[n]:
            count2=count2+1
    
    temp=temp.replace(".","",count2)
    temp=temp.replace("|----","")
    temp=temp.replace("Free", "")
    temp=temp.replace("kilobytes", "")
    temp=temp.replace(" ","")
    freeMem=int(temp)
    useMem=totalMem-1024*freeMem
    useMem=useMem/1024.0/1024.0/1024.0
    useMem=round(useMem,2)
    result=str(useMem)
    result=result+" GB"
    
    return result
        

#获取Txt报告列表
def getTxtReportList(pathStr):
    fileHandle = open(pathStr, 'r');
    listtemp = fileHandle.readlines()
    fileHandle.close()
    return listtemp
    

#获取某命令的开始和结束索引
def getCommandStartEndIndex(command):
    start = 0
    end = 0
    divide = "*********^^^^^^^^^^************^^^^^^^^^^*********"
    for i in range(len(fileList)):
        if command.strip().lower() in fileList[i].strip().lower():
            start = i
    for j in range(start, len(fileList)):
        if divide.strip().lower() in fileList[j].strip().lower():
            end = j
            break
    return {"start":start, "end":end}     
     