# --*-- coding:utf-8 --*--


#获取硬件厂商信息


fileList=None


def execute(context):
    global fileList
    command=""
    pathstr=""
    tempList=[]
    result=""
    
    command = context.get("command")
    commandList=command.split(',')
    pathstr = context.get("path")
    fileList=getTxtReportList(pathstr);
    
    for i in range(len(commandList)):
        dict = getCommandStartEndIndex(commandList[i])
        startIndex = dict["start"]
        endIndex = dict["end"]
        tempList =tempList + fileList[startIndex:endIndex + 1]
    result = extractInfo(tempList)
    context.put("result",result)
    return context


#处理关键信息列表提取字段
def extractInfo(tempList):
    result=""
    count=0

    for i in range(len(tempList)):
        if "Vendor Name" in tempList[i] or "VendorName" in tempList[i]:
            result=tempList[i]
            break
        
    for i in range(len(result)):
        if "." == result[i]:
            count=count+1

    result=result.replace(".","",count-2)
    result=result.replace("Name", "")
    result=result.replace("|----Vendor","").strip()
    return result
        

#获取Txt报告列表
def getTxtReportList(pathStr):
    fileHandle = open(pathStr, 'r');
    listtemp = fileHandle.readlines()
    fileHandle.close()
    return listtemp
    

#获取某命令的开始和结束索引
def getCommandStartEndIndex(command):
    start = 0
    end = 0
    divide = "*********^^^^^^^^^^************^^^^^^^^^^*********"
    for i in range(len(fileList)):
        if command.strip().lower() in fileList[i].strip().lower():
            start = i
    for j in range(start, len(fileList)):
        if divide.strip().lower() in fileList[j].strip().lower():
            end = j
            break
    return {"start":start, "end":end}     