# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                'mapping_view_id', 'mapping_view_name', 'lun_group_id', 'lun_group_name', 'lun_id', 'lun_name', 'capacity', 'host_id', 'hostgroup_id', 'status', 'lun_wwn', 'lun_type'          
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dicv2(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    
    #获取storage gp 回文
    storage_gp_value_lst = []
    if (len(key_lst) == len(attribute_arr)):
        storage_key = attribute_arr[1].strip()
        storage_gp_value_lst = attr_valuelst_dic[storage_key]
    else:
        raise Exception("key Error,please check the Excel model's commands..")
    
    #根据storage gp 回文获取 storate gp bean集合
    storage_lst = get_cmdlst_storagegroup(storage_gp_value_lst)
    storage_bean_lst = get_storagebean_lst(storage_lst)
    
    #获取传入的mapping view　id
    mapping_view_id = attrcom_dic['mapping_view_id'][0].strip()
    mapping_view_name = 'NA'
    temp_storage_gp = Storage_Group_Entity()
    #求mapping_view_name ,temp_storage_gp
    for storage_bean in storage_bean_lst:
        if mapping_view_id == storage_bean.get_uid():
            mapping_view_name = storage_bean.get_name()
            temp_storage_gp = storage_bean
            break
    #alu_temp_lst
    alu_temp_lst = temp_storage_gp.get_alulst()
    alu_egg = Lun_Entity()
    report_path = path
    if 0 == len(alu_temp_lst):
        value_lst.append('NA')
        value_lst.append(mapping_view_name)
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
    else:
        for alu_num in alu_temp_lst:
            cmd_display = "cmd_display_storage_"+mapping_view_name+"_alu"+alu_num
            alu_egg = get_LunEntity(cmd_display,report_path,alu_num)
            
            value_lst.append('NA')
            value_lst.append(mapping_view_name)
            value_lst.append('NA')
            value_lst.append('NA')
            value_lst.append(alu_egg.get_id())
            value_lst.append(alu_egg.get_name())
            value_lst.append(alu_egg.get_capacity())
            value_lst.append('NA')
            value_lst.append('NA')
            value_lst.append(alu_egg.get_status())
            value_lst.append(alu_egg.get_wwn())
            value_lst.append(alu_egg.get_type())
          
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回[storage_bean,...]
#storage_lst:[[单个storage对应的回文],...]
def get_storagebean_lst(storage_lst):
    storage_bean_lst = []
    for lst in storage_lst:
        storage_bean = Storage_Group_Entity()
        storage_bean = get_storagebean_bylst(lst)
        storage_bean_lst.append(storage_bean)
    return storage_bean_lst

def get_LunEntity(cmd_desc,report_path,lun_id):
    flag = False
    temp_lst = []
    lun_bean = Lun_Entity() 
    lun_bean.set_id(lun_id)
    f_handler = open(report_path,'r')
    for line in f_handler:
        if cmd_desc.strip().lower() == line.strip().lower():
            flag = True
            continue
        if True == flag:
            if divide.strip().lower() in line.strip().lower():
                flag = False
                break
            else:
                temp_lst.append(line.strip())
    
    
    if 0 < len(temp_lst):
        for idx,temp in enumerate(temp_lst):
            if ('uid' in temp.lower()) and (':' in temp.lower()):
                wwn_lst = re.split('\\s+',temp)
                lunwwn = wwn_lst[-1].strip()
                lun_bean.set_wwn(lunwwn)
                continue
            elif ('capacity' in temp.lower()) and ('megabytes' in temp.lower()):
                cap_lst = re.split('\\s+',temp)
                cap = cap_lst[-1].strip()
                cap = str(round(float(cap)/1024.0,2))
                lun_bean.set_capacity(cap+'GB')
                continue
            elif (temp and temp.strip().lower().startswith('name')):
                name_lst = re.split('\\s+',temp)
                rep = name_lst[0].strip()
                name = temp.strip()
                name = name.replace(rep,'')
                name = name.strip()
                lun_bean.set_name(name)
                continue
            elif('state' in temp.lower()) and (':' in temp.lower()):
                state_lst = re.split(':',temp)
                state = state_lst[-1]
                state = state.strip()
                lun_bean.set_status(state)
                continue
            elif('meta' in temp.lower()) and (':' in temp.lower() and ('lun') in temp.lower()):
                luntypeArr = re.split(':', temp)
                if luntypeArr[-1].lower().strip() == 'yes':
                    lun_bean.set_type("meta")
                continue
            elif('thin' in temp.lower()) and (':' in temp.lower() and ('lun') in temp.lower()):
                luntypeArr = re.split(':', temp)
                if luntypeArr[-1].lower().strip() == 'yes':
                    lun_bean.set_type("thin")

    return lun_bean
        
        
#获取每个storage所对应的列表
#cmd_value_lst:所有storage gp所对应的回文列表
#功能说明：返回[[单个storage对应的回文],...]
def get_cmdlst_storagegroup(cmd_value_lst):
    #过滤掉无用的数据
    check_lst = []
    for line in cmd_value_lst:
        if '' != line.strip():
            check_lst.append(line)
    cmd_value_lst = check_lst
    #每个storage group对应一个lst
    storagelst_lst = []
    storage_index_lst = []
    for i,line in enumerate(cmd_value_lst):
        if ('storage' in line.lower()) and ('group' in line.lower()) and ('name' in line.lower()):
            storage_index_lst.append(i)
    
    len_indexlst = len(storage_index_lst)
    for j in range(len_indexlst):
        lst = []
        start = storage_index_lst[j]
        try:
            end = storage_index_lst[j+1]
        except:
            end = len(cmd_value_lst)
            
        lst = cmd_value_lst[start:end]
        storagelst_lst.append(lst)
    return storagelst_lst 


#根据一个storage group的回文生成一个 storage对象
def get_storagebean_bylst(storage_lst):
    storage_bean = Storage_Group_Entity()
    
    if (None == storage_lst) or (0 == len(storage_lst)):
        return storage_bean
    for line in storage_lst:
        if ('storage' in line.lower()) and ('group' in line.lower()) and ('name' in line.lower()):
            name = line.split(':')[-1].strip()
            storage_bean.set_name(name)
            continue
        elif ('storage' in line.lower()) and ('group' in line.lower()) and ('uid' in line.lower()):
            id_templst = re.split('\\s+',line.strip())
            id = id_templst[-1].strip()
            storage_bean.set_id(id)
            continue
    #求alu num lst
    start = 0
    end = 0
    has_alu = False
    for i,line in enumerate(storage_lst):
        if ('alu' in line.lower()) and ('number' in line.lower()):
            start = i + 2
            has_alu = True
            continue
        elif 'shareable' in line.lower():
            end = i 
            break
    if has_alu:
        alu_lst = storage_lst[start:end]
        alu_num_lst = []
        for alu in alu_lst:
            alu = alu.strip()
            line_lst = re.split('\\s+',alu)
            num = line_lst[-1].strip()
            alu_num_lst.append(num)
        storage_bean.set_alulst(alu_num_lst)
    else:
        pass
    return storage_bean


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#attrcom_dic = {} #属性名:[命令1,命令2...]
#context：出入的参数
#return:attrcom_dic
def get_attrcom_dicv2(context):
    command = getValueFMap(context,style,'command')
    #去除最后面的';'
    if ';' == command.strip()[-1]:
        command = command[0:-1]
    attrcom_dic= {}
    try:
        for comd in command.split(';'):
            if comd.count(':')==1:
                lst = comd.split(':')
                key = lst[0].strip()
                if (1 < len(lst))and (',' in lst[1]):
                    addValueToMap(attrcom_dic, style, key, lst[1].strip().split(','))
                else:
                    addValueToMap(attrcom_dic, style, key, [lst[1].strip()])
            else:
                value_lst = comd.split(':')
                key = value_lst[0].strip()
                rep = key+':'
                value = comd.replace(rep,'')
                value = value.strip()
                addValueToMap(attrcom_dic, style, key,[value])
    except:
        raise Exception("Not Leagal ,this commands..")
    return attrcom_dic


class Storage_Group_Entity:
    __group_name = 'NA'
    __group_uid = 'NA'
    __alu_lst = []
    def get_name(self):
        return self.__group_name
    def get_uid(self):
        return self.__group_uid
    def get_alulst(self):
        return self.__alu_lst
    def set_name(self,name):
        self.__group_name = name
    def set_id(self,id):
        self.__group_uid = id
    def set_alulst(self,lst):
        self.__alu_lst = lst
        
class Lun_Entity:
    __lun_id = 'NA'
    __lun_name = 'NA'
    __capacity = 'NA'
    __host_id = 'NA'
    __status = 'NA'
    __lun_wwn = 'NA'
    __lun_type = 'NA'
    def set_id(self,id):
        self.__lun_id = id
    def set_name(self,name):
        self.__lun_name = name
    def set_capacity(self,cap):
        self.__capacity = cap
    def set_hostid(self,hostid):
        self.__host_id = hostid
    def set_status(self,sta):
        self.__status = sta
    def set_wwn(self,wwn):
        self.__lun_wwn = wwn
    def set_type(self,type):
        self.__lun_type = type
        
    def get_id(self):
        return self.__lun_id 
    def get_name(self):
        return self.__lun_name  
    def get_capacity(self):
        return self.__capacity
    def get_hostid(self):
        return self.__host_id
    def get_status(self):
        return self.__status
    def get_wwn(self):
        return self.__lun_wwn
    def get_type(self):
        return self.__lun_type
