﻿#coding:utf-8

#Command default time out, 2 minutes.
HOST_CMD_TIMEOUT = 5 * 60
HOST_CMD_SHORT_TIMEOUT = 2 * 60
LINUX_UPSCAN_CMD_TIMEOUT = 10 * 60

TEN = 10
NINE = 9
EGIHT = 8
SEVEN = 7
SIX = 6
FIVE = 5
FOUR = 4
THREE = 3
TWO = 2
ONE = 1
ZERO = 0

LINUX_CMD_DFT_END_LIST = ['#', '$', '>']
#Constants for Linux OS.
QRY_ULTRAPATH_CMD = 'upadm show version'
QRY_MULTIPATHD_STATUS = 'service multipathd status | cat'
QRY_ARRAY_ID_CMD = 'upadm show array'
QRY_VLUN_ID_CMD = 'upadmin show vlun'
High_VER_QRY_VLUN_ID_CMD = 'upadmin show vlun type=all'
QRY_DEV_NAME_CMD = 'lsscsi |grep -Ei "huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa"'
QRY_TGT_PORT_PATH_CMD = 'cat /sys/class/fc_transport/target%s/port_name'
QRY_DISK_PTH_MANAGED_BY_MULTIPATHD_CMD = 'multipath -ll'

#Linux ultrapath evaluation error message key.
ERR_MSG_KEY_QRY_MULTIPATH_FAILED = 'qry.multipath.version.failed'
ERR_MSG_KEY_QRY_MULTIPATHD_FAILED = 'qry.multipathd.srv.sta.failed'
ERR_MSG_KEY_QRY_MULTIPATHD_NO_PRIVILEGE = 'qry.multipathd.no.privilege'
ERR_MSG_KEY_ULTRAPATH_MULTIPATHD_ALL_RUNNING = 'ultrapath.and.multipathd.all.running'
ERR_MSG_KEY_ULTRAPATH_MULTIPATHD_ALL_NOT_RUNING = 'ultrapath.and.multipathd.all.not.running'
ERR_MSG_KEY_QRY_ARRAY_ID_FAILED = 'qry.array.id.failed'
ERR_MSG_KEY_QRY_ARRAY_LUN_PATH_FAILED = 'qry.array.lunpath.failed'
ERR_MSG_KEY_QRY_SINGLE_LUN_PATH_FAILED = 'qry.single.lunpath.failed'
ERR_MSG_KEY_LUN_PATH_NOT_PASSWED = 'lunpath.evalute.not.passed'
ERR_MSG_KEY_QRY_ARRAY_ID_EMPTY = 'qry.array.id.empty'

ERR_MSG_KEY_QRY_VLUN_ID_FAILED = 'qry.vlun.id.failed'
ERR_MSG_KEY_QRY_VLUN_ID_EMPTY = 'qry.vlun.id.empty'

OS_TYPE_WINDOWS = "Windows"
OS_TYPE_LINUX = "Linux"
OS_TYPE_SOLARIS = "Solaris"
OS_TYPE_AIX = "AIX"

OS_TYPE_LINUX_LOW = "linux"
OS_TYPE_AIX_LOW = "aix"
OS_TYPE_SOLARIS_LOW = "solaris"
OS_TYPE_SUNOS_LOW = "sunos"
OS_TYPE_VMWARE_LOW = "vmkernel"
OS_TYPE_WINDOWS_LOW = "windows"
OS_TYPE_FUSIONSPHERE_LOW = "fusionsphere"

#buglist3
ERR_MSG_SOLARIS_REPORT_LUN_CHECK_UNABLE_EVAL = "solaris.report.lun.check.unable.eval"
ERR_MSG_SOLARIS_REPORT_LUN_CHECK_NOT_PASSED = "solaris.report.Lun.check.failed"
#buglist5
ERR_MSG_DIF_NOT_IDENTITY_UNABLE_EVAL = "dif.not.identity.check.unable.eval"
ERR_MSG_DIF_NOT_IDENTITY_NOT_PASSED = 'dif.not.identity.check.not.passed'
ERR_MSG_MULTIPATHD_NO_HW_DISK_FOUND = 'no.hw.disk.managed.by.multipathd'

#Suggest message key.

SUGGEST_MSG_KEY_QRY_MULTIPATHD_USE_ROOT = 'qry.multipathd.use.root'

LINUX_LOWER_ULTRAPATH_VER = '5.01.017'
LINUX_MIDDLE_ULTRAPATH_VER = '8.01.051'
CTRL_ID_RE_PATTERN = '\d+[a-dA-D]'
CTRL_ID_NEW_RE_PATTERN = '\'\d*[a-dA-D]'
NEW_PATH_FOUND_PATTERN = 'controller.*\d+[a-dA-D].*path'
NEW_PATH_FOUND_NEW_PATTERN = 'controller.*\d*[a-dA-D].*path'
#Linux multipathd service.
TARGET_PORT_NUM_PATTERN = '\d+:\d+:\d+'
NEW_HW_DISK_PATTERN = 'dm\-\d+\s+(huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa)'

ERR_MSG_KEY_QRY_TGT_PORT_NUM_FAILED = 'qry.tgt.port.number.failed'
ERR_MSG_KEY_QRY_TGT_PORT_NUM_EMPTY = 'qry.tgt.port.number.empty'
ERR_MSG_KEY_QRY_TGT_PORT_PATH_EMPTY = 'qry.tgt.port.path.empty'


#vmware
CHECK_FAIL = 0
CHECK_PASS = 1
SOFT_WARE_VERSION = "software version"
ULTRAPATH_VERSION = "ultrapath for"
DRIVER_VERSION = "driver version"
MULTIPATH_PLUGIN = "multipath plugin"
MULTI_PATH_TYPE = "type"
NOT_PASS_VLUN_IDS = "failVluns"
NOT_PASS_DEVICE = 'failDevices'
ITEM_KEY = "multipath_check"
ULTR_LUN_COMMAND = "esxcli upadm show vlun"
NMP_DEVICE_COMMAND = "esxcfg-mpath -b | grep -E -i 'huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa'"
HW_DISK_KEYWORD = 'huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa'
#show lun command
SHOW_LUN_COMMAND = "esxcli upadm show vlun -l "
#ultra path version
ULTRA_PATH_VERSION_COMMAND = "esxcli upadm show version"
#check nmp path exist command
NMP_EXIST_COMMAND = "esxcli storage core device list"
#os name command
OS_NAME_COMMAND = "uname -a"
#临界版本号
CMP_MULTI_PATH_VERSION = 801051
#自研多路径标识
ULTRA = 0
#自带多路径标识
NMP = 1
MAGIC_INT16 = 16
MAGIC_INT0 = 0
MAGIC_INT1 = 1
MAGIC_INT2 = 2
#结果标志
RESULT_FLAG = "root@~ #result\n"
#自研多路径评估不通过
ULTRA_NOT_PASS_TIPS = 'eval.host.mulitipath.info.check.ulrapath.not.pass.tips'
ULTRA_HYPER_METRO_VLUN_NOT_PASS_TIPS = 'eval.host.mulitipath.hyper.lun.not.pass'
ULTRA_VLUN_NOT_PASS_TIPS = 'eval.host.mulitipath.normal.lun.and.hyper.lun.not.pass'

#自带多路径评估不通过
NMP_NOT_PASS_TIPS = 'eval.host.mulitipath.info.check.nmp.not.pass.tips'
#操作系统在支持范围内
OS_NOT_SUPPORT_TIPS = 'eval.host.mulitipath.info.check.os.not.support.tips'
#评估不通过
NO_MULTIPATH_UNABLE_TIPS = 'eval.host.mulitipath.info.check.no.multipath.unable.eval.tips'
#无法评估
CHECK_UNABLE_TIPS = 'eval.host.mulitipath.info.check.unable.eval.tips'
#hp-ux所有在线wwpn查询失败，无法评估
CHECK_HPUX_ONLINE_WWPN_UNABLE_TIPS = 'eval.host.mulitipath.info.check.unable.eval.tips.wwpn'
#query all device fail
QUERY_ALL_DEVICE_FAIL_TIPS = "eval.host.multipath.info.check.all.device.query.fail.tips"
#query  device part fail
QUERY_PARAT_DEVICE_FAIL_TIPS = "eval.host.multipath.info.check.part.device.query.fail.tips"
#query all lun fail
QUERY_ALL_LUN_FAIL_TIPS = "eval.host.multipath.info.check.all.lun.query.fail.tips"
#query part lun fail,and normal lun not redundant.
QUERY_PART_LUN_FAIL_TIPS = "eval.host.multipath.info.check.part.lun.query.fail.tips"

QRY_FAIL_HYPER_LUN_NO_REDUNDANT="eval.host.multipath.info.check.part.lun.query.fail.hyper.lun.no.redundant.tips"
QRY_FAIL_NORMAL_AND_HYPER_LUN_NO_REDUNDANT="eval.host.multipath.info.check.part.lun.query.fail.normal.and.hyper.lun.no.redundant.tips"

EVAL_NOTPASS = "eval.host.multipath.hpv1v2.notpass.tips"

#无法评估
#ioscan -funC disk
#无法评估，请检查物理链路状态是否正常。若有疑问，请联系技术支持工程师协助处理。
EVAL_NOTEVAL_FCDISK = "eval.host.multipath.hpv1v2.fcdisk.cannot.tips"


#pvdisplay /dev/dsk/c22t0d3 | grep 'PV Name'
#无法评估，请检查主机卷管理软件是否正确配置。若有疑问，请联系技术支持工程师协助处理。
EVAL_NOTEVAL_PV = "eval.host.multipath.hpv1v2.pvname.cannot.tips" 

#ioscan -funC fc
#无法评估， 请检查HBA卡是否正常。若有疑问，请联系技术支持工程师协助处理。
EVAL_NOTEVAL_FCNOT = "eval.host.multipath.hpv1v2.fcnot.cannot.tips"
