# --*-- coding:utf-8 --*--


#获取主机名
import sys
import os
import re
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import getCommandRetFromTxt 


def execute(context):
    tempList = getCommandRetFromTxt(context)
    result = extractInfo(tempList)
    context.put("result", result)
    return context


def extractInfo(tempList):
    isJdbc = False
    result = 'NA'
    index = -1
    for i in range(len(tempList)):
        if - 1 == index:
            if "TYPE" in tempList[i]:
                lineStr = tempList[i].strip()
                lineList = []
                if "][" in lineStr:
                    isJdbc = True
                    lineList = lineStr.split("][")
                else:
                    lineList = re.split('\s+', lineStr)
                for j in range(len(lineList)):
                    if "TYPE" == lineList[j]:
                        index = j
                        break
        else:
            lineStr = tempList[i].strip()
            lineList = []
            if isJdbc:
                lineList = lineStr.split("|")
            else:
                lineList = re.split('\s+', lineStr)
            if index < len(lineList):
                if  '--' not in lineList[index]:
                    type = lineList[index]
                    if "NA" == result:
                        result = type
                    else:
                        result = result + ';' + type
    return result
        
