# coding=utf-8
__author__ = '******'
# 获取linux主机的一些基础信息:名称、版本、CPU、内存等.
import os
import re
import sys
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..")
sys.path.append(path)
from common.contentParse import getCommandRet

cmd_info_id = ["cmd_display_os_basic_uname" ,
               "cmd_info_os_basic_oslevel" ,
			   "cmd_info_os_basic_bootinfo",
               "cmd_info_os_basic_prtconf" ,
               "cmd_info_os_basic_vmstat",
               "cmd_info_os_basic_kernel_bit",
               ]
			
cmd_info_desc = ["uname -a",
                 "oslevel -s",
			     "bootinfo -K",
                 "prtconf",
                 "vmstat 1 5",
                 "bootinfo -K",
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
        
    return getCommandRet(context, cmd_info_id, cmd_info_desc)