# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #{属性名:[对应列表]}
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    #{属性名:[对应回文的列表]}
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    
    att_similarvaluelst_dic = get_attrsimilarvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    if len(key_lst)==len(attribute_arr):
        pass
    else:
        raise Exception('key not match')            
    
    deviceList = []
    #device vendor
    deviceList = get_device_vendor_lst(attr_valuelst_dic[key_lst[0]])
    #设置：capacity
    caplst = att_similarvaluelst_dic[attribute_arr[2]]
    capList = get_caplst(deviceList,caplst)
    #设置: lunwwn
    lunwwn_lst = attr_valuelst_dic[attribute_arr[3]]
    wwnlst = get_lunwwn_lst(capList, lunwwn_lst)
    #设置：vgname pvname
    vgname_lst = attr_valuelst_dic[attribute_arr[-1]]
    vgdevice_lst = get_vgdevicelst(wwnlst,vgname_lst)

    for obj in deviceList:
        value_lst.append(obj.get_device())
        value_lst.append(obj.get_vendor())
        value_lst.append(obj.get_capacity())
        value_lst.append(obj.get_wwn())
        value_lst.append(obj.get_pvname())
        value_lst.append(obj.get_vgname())

    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#return {属性名:[回文列表]}
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

#return 模糊获取命令回文{属性名:[回文列表]}
def get_attrsimilarvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = similarcomdsbyfile_disk(all_comds_lst,path)
    return get_attrsimilar_lst_dic(attrcom_dic,all_comds_byfile,path)

def similarcomdsbyfile_disk(comds,path):
    all_comds_byfile = []
    file_handler = open(path,'r')
    for line in file_handler:
        for comd in comds:
            if comd.lower() in line.lower():
                all_comds_byfile.append(line.strip())
            else:
                continue
    file_handler.close()
    return all_comds_byfile


#device ,vendor
def get_device_vendor_lst(tempList):
    diskObjList = []
    if not is_success(tempList):
        #长度为0或者有失败标识
        diskObj = Disk_Entity()
        diskObjList.append(diskObj)
        return diskObjList
     
    tempList = tempList[2:-1]
    for line in tempList:
        if 'available' in line.lower():
            line = line.strip()
            lst = re.split('\\s+', line)
            diskObj = Disk_Entity()
            diskObj.set_device(lst[0])
            if 8 == len(lst):
                diskObj.set_vendor(lst[3])
                diskObjList.append(diskObj)
            else:
                diskObjList.append(diskObj)
    return diskObjList

#capacity    
def get_caplst(deviceList,templst):
    
    devlst = deviceList
    if 0 == len(templst):
        return devlst
    capblock_lst = get_block_lst(templst)
    for dev in devlst:
        for i,lst in enumerate(capblock_lst):
            lst = lst[1:-1]
            for j in range(len(lst)):
                if dev.get_device().lower() in lst[j]:
                    cap = lst[j+1].strip()
                    cap = round(float(cap)/1024.0,2)
                    cap = str(cap)+ " GB"
                    dev.set_capacity(cap)
    return devlst

#lunwwn
def get_lunwwn_lst(deviceList, templst):
    wwnlst = deviceList
    if not is_success(templst):
        return wwnlst
    for dev in  wwnlst:
        for line in templst:
            if dev.get_device().lower() in line.lower():
                vlst = re.split('\\s+',line)
                dev.set_wwn(vlst[-5].strip())
    return  wwnlst

#vgname pvname
def get_vgdevicelst0(wwnlst,vgname_lst):
    vgdevice_lst = wwnlst
    if 0 == len(vgname_lst):
        return vgdevice_lst
    for dev in vgdevice_lst:
        for line in vgname_lst:
            if dev.get_device().lower() in line.lower():
                lst = re.split('\\s+',line)
                vgname = lst[2].strip()
                pvname = lst[0].strip()
                if pvname == dev.get_device():
                    dev.set_vgname(vgname)
                    dev.set_pvname(pvname)
                else:
                    dev.set_vgname('NA')
                    dev.set_pvname(pvname)
    return vgdevice_lst


def get_vgdevicelst(wwnlst,vgname_lst):
    vgdevice_lst = wwnlst
    if 0 == len(vgname_lst):
        return vgdevice_lst
    if not(None == vgdevice_lst):
        for dev in vgdevice_lst:
            for line in vgname_lst:
                lst = re.split('\\s+',line)
                vgname="NA"
                pvname ="NA"
                if len(lst)>2:
                    vgname = lst[2].strip()
                    pvname = lst[0].strip()
                if pvname == dev.get_device():
                    dev.set_vgname(vgname)
                    dev.set_pvname(pvname)
    return vgdevice_lst

#PV name 
def get_pv_lst(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        result.append('NA')
        return result
    
    for line in tempList:
        if failStr.lower() in line.lower():
            result.append('NA')
            return result
    tempList = tempList[2:-1]
    for line in tempList:
        tempResult = re.split('\\s+', line)
        result.append(tempResult[0])
    return result


#return [[单个命令的回文]..]
def get_block_lst(tempList):
    index = 0 
    txtList = []
    resultlst = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    for lst in txtList:
        #去掉空的项
        lst = checktempList(lst)
        resultlst.append(lst)
    return resultlst
       
class Disk_Entity:
    __disk_device = 'NA'
    __disk_vendor = 'NA'
    __disk_capacity = 'NA'
    __disk_wwn = 'NA'
    __disk_pvname = 'NA'
    __disk_vgname = 'NA'
    def get_device(self):
        return self.__disk_device
    def get_vendor(self):
        return self.__disk_vendor
    def get_capacity(self):
        return self.__disk_capacity 
    def get_wwn(self):
        return self.__disk_wwn
    def get_pvname(self):
        return self.__disk_pvname
    def get_vgname(self):
        return self.__disk_vgname
    def set_device(self,device):
        self.__disk_device = device
    def set_vendor(self,vendor):
        self.__disk_vendor = vendor
    def set_capacity(self,capacity):
        self.__disk_capacity  = capacity
    def set_wwn(self,wwn):
        self.__disk_wwn = wwn
    def set_pvname(self,pvname):
        self.__disk_pvname = pvname
    def set_vgname(self,vgname):
        self.__disk_vgname = vgname
