# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global LENGTH
global key_lst  #对应Excel中属性列表
global attribute_arr

#对应excel中的属性字段
key_lst = ["file_system","mounted_point","total_capacity","capacity_used"]

#数据迁移 ：获取Linux主机集群，文件系统信息
def execute(context):
    rightcmd = False
    commandneed = ""
    tempstr = ""
    attribute_arr = []
    LENGTH = 0
    
    attrcom_dic = get_attrcom_dic(context)
    
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    
    command_lst = get_purecommands_lst(attrcom_dic)
    
    file_attr_value = getValueFMap(attr_valuelst_dic,style,key_lst[0])
    
    value_lst = []
    fileObjList = []
    fileObjList = get_fileinfo(file_attr_value)
    
    for obj in fileObjList:
        value_lst.append(obj.get_name())
        value_lst.append(obj.get_mount())
        value_lst.append(obj.get_capacity())
        value_lst.append(obj.get_used())
    
        
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
            
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,"result",result)
    return context


#返回属性名与回文列表组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

def get_fileinfo(tempList):
    fileObjList = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        fileObj = File_Entity()
        fileObjList.append(fileObj)
        return fileObjList
    
    for line in tempList:
        if failStr.lower() in line.lower():
            fileObj = File_Entity()
            fileObjList.append(fileObj)
            return fileObjList
    if len(tempList) > 3 :
        tempList = tempList[2:-1]
        
    if 0 == len(tempList):
        fileObj = File_Entity()
        fileObjList.append(fileObj)
        return fileObjList
    
    tempList = tempList[2:]
    
    for line in tempList:
        tempArr = re.split('\\s+', line)
        fileObj = File_Entity()
        fileObj.set_name(tempArr[0])
        fileObj.set_mount(tempArr[-1])
        fileObj.set_capacity(tempArr[1]+'GB')
        fileObj.set_used(tempArr[-2])
        fileObjList.append(fileObj)
    return fileObjList
    

class File_Entity:
    __file_name = 'NA'
    __file_mount = 'NA'
    __file_capacity  = 'NA'
    __file_used = 'NA'
    
    def get_name(self):
        return self.__file_name
    def get_mount(self):
        return self.__file_mount
    def get_capacity(self):
        return self.__file_capacity
    def get_used(self):
        return self.__file_used
    
    def set_name(self,name):
        self.__file_name = name
    def set_mount(self,mount):
        self.__file_mount = mount
    def set_capacity(self,capacity):
        self.__file_capacity = capacity
    def set_used(self,used):
        self.__file_used = used
