# coding=utf-8
__author__ = '******'
# 数据迁移: 获取linux主机: 阵列信息，磁盘信息，文件系统信息等
import re
CLI = None
LANGUAGE = None
CHECK_FAIL = 0
CHECK_PASS = 1
cmd_info_id = [
               #逻辑卷
                "cmd_info_migrate_cluster_disk_adb",
                "cmd_info_migrate_cluster_disk_aset",
                "cmd_info_migrate_cluster_disk_astat",
                "cmd_info_migrate_cluster_disk_astatp",
                
                "cmd_info_migrate_cluster_disk_vxvm",
                "cmd_info_migrate_cluster_disk_plorer",
                #文件系统
                "cmd_info_migrate_cluster_fsys_fsSStab",
                "cmd_info_migrate_cluster_fsys_mount",
                "cmd_info_migrate_cluster_fsys_lfslist",
                "cmd_info_migrate_cluster_fsys_filesysinfo"
                #磁盘信息
                "cmd_info_migrate_cluster_disk_format",
                "cmd_info_migrate_cluster_disk_alR",
                "cmd_info_migrate_cluster_disk_df"
                
                
                
            ]

            
cmd_info_desc = [
                 #逻辑卷
                 "metadb",  
                 "metaset",
                 "metastat",
                 "metastat -p",
                 
                 "pkginfo -l VRTSvxvm",                    
                 "/opt/VRTSspt/VRTSexplorer/VRTSexplorer",
                 
                 #文件系统：类型、挂载点、大小等
                 "cat /etc/vfstab",    
                 "mount",
                 "zfs list",
                 "bdf",
                 #磁盘信息
                 "echo | format",
                 "ls -alR /dev/*",
                 "df –k",
                   
                 
                 
                 ]


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    for rg in range(len(cmd_info_id)):
        cmd_display_temp = CLI.execCmdNoLogTimout(cmd_info_desc[rg], 60)
        cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:], cmd_display_temp)
        if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute failed\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + ":\t执行失败\r\n"
        else:
            if "en" == LANGUAGE:
                fun_err_msg += cmd_info_desc[rg] + ":\texecute success\r\n"
            else:
                fun_err_msg += cmd_info_desc[rg] + ":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg
