#coding:utf-8
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
sys.path.append(path)
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import * 
from host_wwpn import getAllHbaObjs



def execute(context):
    '''j
    @summary:脚本入口
    @param context:上下文
    @return:处理过后的上下文
    '''
    hbaObjs = getAllHbaObjs(context)
    result  = getAllHbaDrVersions(hbaObjs)
    context.put('result',result)
    return context


def getAllHbaDrVersions(hbas):
    '''
    @summary: 驱动版本获取
    @param hbas:hba列表
    @return:驱动版本
    '''
    drVersions = ''
    for hba in hbas:
        if 'ONLINE'.lower() != hba.getState().lower() :
            continue
        drVersions = drVersions +';'+ hba.getDrVersion()
    if not drVersions:
        drVersions = 'NA'
    else:
        drVersions = drVersions[1:]
    return drVersions

