# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global divide
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'hba_instance', 
                     'hba_model',
                     'wwn',
                     'status'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    hbaInsList = []
    hbaModList = []
    hbaLunList = []
    hbaStaList = []
    hbaInsList = get_hba_instance(attr_valuelst_dic[key_lst[0]])
    hbaModList = get_hba_model(attr_valuelst_dic[key_lst[1]])
    hbaLunList = get_hba_wwn(attr_valuelst_dic[key_lst[2]])
    hbaStaList = get_hba_status(attr_valuelst_dic[key_lst[3]])
    listLen = len(hbaInsList)
    if len(hbaModList) == listLen and len(hbaLunList) == listLen and len(hbaStaList) == listLen:
        for i in range(len(hbaInsList)):
            value_lst.append(hbaInsList[i])
            value_lst.append(hbaModList[i])
            value_lst.append(hbaLunList[i])
            value_lst.append(hbaStaList[i])
    else:
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#功能说明：返回hbaInstance
def get_hba_instance(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    checkHbaIns = ''
    if 0 == len(tempList):
        result.append('NA')
        return result
    
    for line in tempList:
        if failStr.lower() in line.lower():
            result.append('NA')
            return result
        
    resultLine = ''
    resultList = []
    if len(tempList) > 2:
        resultLine = tempList[2]
        result = re.split('\\s+', resultLine)
        return result
    else:
        result.append('NA')
        return result

#功能说明：返回hba model
def get_hba_model(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    checkHbaIns = ''
    if 0 == len(tempList):
        result.append('NA')
        return result
    
    for line in tempList:
        if failStr.lower() in line.lower():
            result.append('NA')
            return result
    
    if len(tempList) > 2:
        tempList = tempList[2:-1]
        for line in tempList:
            result.append(line.strip())
        return result
    else:
        result.append('NA')
        return result

#功能说明：返回hbawwn 
def get_hba_wwn(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    checkHbaIns = ''
    if 0 == len(tempList):
        result.append('NA')
        return result
    
    for line in tempList:
        if failStr.lower() in line.lower():
            result.append('NA')
            return result
    
    if len(tempList) > 2:
        tempList = tempList[2:-1]
        for line in tempList:
            result.append(line.strip())
        return result
    else:
        result.append('NA')
        return result
    
#功能说明：返回hba卡状态
def get_hba_status(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    checkHbaIns = ''
    if 0 == len(tempList):
        result.append('NA')
        return result
    
    for line in tempList:
        if failStr.lower() in line.lower():
            result.append('NA')
            return result
    
    if len(tempList) > 2:
        tempList = tempList[2:-1]
        for line in tempList:
            result.append(line.strip())
        return result
    else:
        result.append('NA')
        return result
    
def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_hba_instance(tempList)
    elif key == key_lst[1]:
        return get_hba_model(tempList)
    elif key == key_lst[2]:
        return get_hba_wwn(tempList)
    elif key == key_lst[3]:
        return get_hba_status(tempList)
    else:
        return "Key Error"

    
