# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global LENGTH
global key_lst  #对应Excel中属性列表
global attribute_arr
global fail_flag 
fail_flag = "TOOLKIT_EXE_CMD_FAILED"

#对应excel中的属性字段
key_lst = ["file_system","mounted_point","total_capacity","capacity_used"]

#数据迁移 ：#获取Linux主机集群，文件系统信息
def execute(context):
    rightcmd = False
    commandneed = ""
    tempstr = ""
    attribute_arr = []
    LENGTH = 0
    attrcom_dic = get_attrcom_dic(context)
    #求json name
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    command_lst = get_purecommands_lst(attrcom_dic)
    
    #检查命令是否一样
    for cmd in command_lst:
        if cmd.strip().lower() == command_lst[-1].lower():
            rightcmd = True
            commandneed = cmd
        else:
            rightcmd = False
    if rightcmd:
        addValueToMap(context,style,'command',commandneed)
        
        
    #求attribute_arr
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
            
    tempList = getCommandRetFromTxt(context)
    
    checkList = []
    #过滤不合法的回文字段
    for line in tempList:
        if '' != line.strip():
            checkList.append(line)
    tempList = checkList
    for i,line in enumerate(tempList):
        if ('filesystem' in line.lower()) and ('type' in line.lower()):
            tempList = tempList[i:]
            break
    
    for line in tempList:
        if fail_flag in line:
            tempList.remove(line)
    tempstr = ';'.join(tempList)
    tempstr = tempstr.lower()
    tempstr = tempstr.replace("mounted on", "mountedon")
    tempstr = tempstr.strip()
    temp_value_lst = re.split(';',tempstr)
    LENGTH = len(re.split('\\s+',temp_value_lst[0])) 
    tempstr = ' '.join(temp_value_lst)
    
    value_lst_temp = re.split('\\s+',tempstr)
    #去掉""
    for line in value_lst_temp:
        if '' == line.strip():
            value_lst_temp.remove(line)
    
    #end
    value_lst = get_value_lst(LENGTH, value_lst_temp)
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,"result",result)
    return context


def get_value_lst(length,values_temp):
    v_lst = []
    row_num = len (values_temp)/length
    # 行数：1 - 6
    for i in range(1,row_num):
        v_lst.append(values_temp[length*i])
        v_lst.append(values_temp[length*i+6])
        cap = values_temp[length*i+2]
        if 'g' in cap.lower():
            cap = cap.replace('g',' GB')
        elif 'm' in cap.lower():
            cap = cap.replace('m', ' MB')
        else:
            pass
        v_lst.append(cap)
        v_lst.append(values_temp[length*i+5])
    return v_lst


#return {属性名:[回文列表]}
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)
