# --*-- coding:utf-8 --*--

divide = "*********^^^^^^^^^^************^^^^^^^^^^*********"

#获取hba卡的超时信息
def execute(context):
    #获取HBA卡超时信息的回文
    hbaTmoRet = getCommandRetFromTxt(context)
    if 0 == len(hbaTmoRet):
        hbaTmoRet = "NA"
        context.put("result", hbaTmoRet)
        return context

    hbaTmoTet_list = hbaTmoRet.splitlines()
    hbaTmoRet = hbaTmoTet_list[-1]
    context.put("result", hbaTmoRet)
    return context

def getCommandRetFromTxt(context):
    '''
    @summary: 从mml文件中获取包含关键的回显信息
    @param filePath: 文件路径
    @param keyword: 关键字
    @return: MML回显组成的列表
    '''
    cmdRetList = []
    flag = False
    
    command = context.get("command")
    commandList = command.split(',')
    filePath = context.get("path")
    
    fileHandle = open(filePath, 'r')
    for i in range(len(commandList)):
        for line in fileHandle:
            if commandList[i].strip().lower() in line.strip().lower():
                flag = True
                continue
            if True == flag:
                if divide.strip().lower() in line.strip().lower():
                    flag = False
                    break
                else:
                    cmdRetList.append(line.strip())
     
    fileHandle.close()  
    return "\n".join(cmdRetList)
