# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'cluster_name', 
                     'cluster_version',
                     'cluster_status'
            ]

#获取Linux主机集群 Server信息

def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    if not(len(key_lst) == len(attribute_arr)):
        raise Exception('key_lst Error,please check it.')
    cluster_lst = attr_valuelst_dic[attribute_arr[0]]
    
    cluster_block_lst = get_block_lst(cluster_lst)
    #PaceMaker lst
    pacemaker_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_crmadmin' in lst_temp) or ('cmd_display_cluster_classes' in lst_temp) or ('cmd_display_cluster_crm_mon' in lst_temp):
            pacemaker_lst.append(lst)
    #RHCS lst
    rhcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_RHCS' in lst_temp) or ('cmd_display_cluster_clustat' in lst_temp):
            rhcs_lst.append(lst)
    #VCS lst
    vcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_VRTSvcs' in lst_temp) or ('cmd_display_storage_foundation_hastatus_sum' in lst_temp):
            vcs_lst.append(lst)
            
    #RAC lst
    rac_lst = []
    rac_versionlst = []
    rac_statuslst = []
    for lst in cluster_block_lst:
        
        lst_temp = ';'.join(lst)
        
        if ('cmd_display_cluster_findrac' in lst_temp.lower()):
            rac_lst.append(lst)
        if ('sql_display_cluster_ora_cversion' in lst_temp.lower()):
            rac_versionlst.append(lst)
        if ('cmd_display_cluster_racstat' in lst_temp.lower()):
            rac_statuslst.append(lst)
    
    
    #RAC obj 
    rac_obj = Cluster_Info()
    has_racone = False
    has_racsec = False
    has_rac = False
    if 0 != len(rac_lst):
        if (len(rac_lst[0]) > 2):
            rac_result_lst = rac_lst[0]
            for line in rac_result_lst[2:-1]:
                if ('crs_stat' in line):
                    has_racone = True
                    break
    if 0 != len(rac_statuslst):
        has_racsec = True
        
    #状态回文
    rac_cluster_statuslst_temp = attr_valuelst_dic[attribute_arr[2]]
    rac_cluster_statuslst_block = rac_status_block = get_block_lst(rac_cluster_statuslst_temp)
    rac_cluster_statuslst = get_valuelst_bydesc(rac_cluster_statuslst_block,"cmd_display_cluster_racstat")
    
    has_rac = has_racone and has_racsec
    
    if has_rac:
        rac_obj.set_name('RAC')
        try:
            rac_version = get_racversion(rac_versionlst[0])
            rac_obj.set_version(rac_version)
        except:
            pass
        rac_status = ''
        if len(rac_cluster_statuslst[3:-1]) > 0:
            rac_status = '\\n'.join(rac_cluster_statuslst[3:-1])
        else:
            rac_status = 'NA'
        
        rac_obj.set_status(rac_status)
    #PaceMaker obj
    pacemaker_obj = Cluster_Info()
    has_pace = True
    if 0 == len(pacemaker_lst):
        has_pace = False
        
    for pacelst in pacemaker_lst:
        has_pace = is_success(pacelst)
        has_pace = has_pace & has_pace
        
    if has_pace:
        pacemaker_obj.set_name('NA')
               
    #RHCS obj
    rhcs_obj = Cluster_Info()
    has_rhcs = False
    has_rhcs = has_cluster(rhcs_lst)
    
    rhcs_cluster_statuslst = attr_valuelst_dic[attribute_arr[2]]
    rhcs_status_block = get_block_lst(rhcs_cluster_statuslst)
    rhcs_status_lst = []
    rhcs_status_lst = get_valuelst_bydesc(rhcs_status_block,"cmd_display_cluster_clustat")
    if has_rhcs:
        rhcs_obj.set_name('RHCS')
        state = ""
        if len(rhcs_status_lst[2:-1])>0:
            state = '\\n'.join(rhcs_status_lst[2:-1])
        else:
            state = 'NA'
        rhcs_obj.set_status(state)
        
    #VCS obj
    vcs_obj = Cluster_Info()
    has_vcs = True
    if 0 == len(vcs_lst):
        has_vcs = False
    for vcslst in vcs_lst:
        has_vcs = is_success(vcslst)
        has_vcs = has_vcs & has_vcs
    if has_vcs:
        vcs_obj.set_name('NA')
        
    #cluster obj 集合
    cluster_obj_lst = []
    if rac_obj.get_name() != 'NA':
        cluster_obj_lst.append(rac_obj)
    if pacemaker_obj.get_name() != 'NA':
        cluster_obj_lst.append(pacemaker_obj)
    if rhcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(rhcs_obj)
    if vcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(vcs_obj)
        
    #求value_lst
    for obj in cluster_obj_lst:
        value_lst.append(obj.get_name())
        value_lst.append(obj.get_version())
        value_lst.append(obj.get_status())
    
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    
    addValueToMap(context,style,'result',result)
    return context

#获取rac集群版本
def get_racversion(templst):
    result = 'NA'
    if 0 == len(templst):
        return result
    if not is_success(templst):
        return result
    for line in templst:
        if ('core' in line.lower()) and ('production' in line.lower()):
            result = line
            break
    if 'NA' != result:
        lst = re.split('\\s+',result)
        try:
            result = lst[1].strip()
        except:
            result = 'NA'
    return result
    
 
#功能说明：返回单个命令的回文
def get_block_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList


def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)



class Cluster_Info:
    __name = 'NA'
    __version = 'NA'
    __status = 'NA'
    def set_name(self,name):
        self.__name = name
    def set_version(self,ver):
        self.__version = ver
    def set_status(self,status):
        self.__status = status
    def get_name(self):
        return self.__name
    def get_version(self):
        return self.__version
    def get_status(self):
        return self.__status
