# --*-- coding:utf-8 --*--
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import * 

#获取操作系统名称
def execute(context):
    command=""
    pathstr=""
    tempList=[]
    result=""
    
    command = context.get("command")
    commandList=command.split(',')
    pathstr = context.get("path")
    
    for i in range(len(commandList)):
        tempList =tempList + getCommandRetFromTxtWithPara(context, commandList[i])
    result= extractInfo(tempList,context)
    context.put("result",result)
    
    return context



def isOelUekVersion(context):
    '''
    @summary: 判断Oralce Linux是不是UEK版本
    @context:上下文
    @return False:不是 True:是
    '''
    uekCmd = "cmd_display_os_basic_uname"
    lst = getSingleOrMoreCommandRetFromTxt(context, uekCmd, False)
    lst = check_lst(lst)
    if len(lst) <= 2:
        return False
    if 'uek' in lst[2].lower():
        return True
    return False

        

#处理关键信息列表提取字段
def extractInfo(tempList,context):
    op_sys_info=""
    dev_type=""
    for t in range(len(tempList)):
        op_sys_info=op_sys_info+tempList[t]+'\n'

    tem_line = op_sys_info.splitlines()
    if 'Asianux' in op_sys_info:
        for i in range(0, len(tem_line)):
            #####################     Suse Area    #####################
            if 'Asianux' in tem_line[i]:
                dev_type = 'Asianux ' + tem_line[i].split()[2]
                break
    elif 'Debian' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Debian' in tem_line[i]:
                dev_type = 'Debian ' + tem_line[i].split()[2]
                break
    elif 'Oracle Linux' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Oracle Linux' in tem_line[i]:
                dev_type = 'Oracle Linux ' + tem_line[i].split()[4]
                if(isOelUekVersion(context)):
                    dev_type = dev_type + ' UEK'
                break
    elif 'SUSE' in op_sys_info:        
        for i in range(0,len(tem_line)):
            if 'VERSION' in tem_line[i]:
                version = tem_line[i].split('=')[1].strip()
                dev_type = 'SUSE '+version
            if 'PATCHLEVEL' in tem_line[i]:
                level = tem_line[i].split('=')[1].strip()
                if '0' == level:
                    dev_type = dev_type
                else:
                    dev_type = dev_type + ' ' + 'SP' + level
                break
    #####################   Red Hat Area    #####################
    elif 'Red Hat' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Red Hat' in tem_line[i] and "=" not in tem_line[i]:
                dev_type = "Red Hat " + tem_line[i].split()[6]
                break
    #####################   CentOS Area    #####################
    elif 'CentOS' in op_sys_info: 
        for i in range(0, len(tem_line)):
            if 'CentOS' in tem_line[i]:
                dev_type = "CentOS " + tem_line[i].split()[2]
                if dev_type == 'CentOS release':
                    dev_type = "CentOS " + tem_line[i].split()[3]
                    if(dev_type.count('.')>=2):
                        lst = dev_type.split('.')
                        dev_type = lst[0]+'.'+lst[1]
                break
    #####################   XenServer Area    #####################
    elif 'XenServer' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'XenServer' in tem_line[i]:
                dev_type = "XenServer " + tem_line[i].split()[3];
                break
            #####################   Ubuntu Area    #####################
    elif 'Ubuntu' in op_sys_info:
        for i in range(0, len(tem_line)):
            if 'Ubuntu' in tem_line[i]:
                dev_type = ""
                resultList=tem_line[i].split()
                if 'lts' in tem_line[i].lower():
                    dev_type = resultList[0] + ' ' + resultList[1] + ' LTS'
                else:
                    dev_type = resultList[0] + ' ' + resultList[1] 
                break
    
    hostos=dev_type
    return hostos

