#coding:utf-8
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
sys.path.append(path)
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import * 
from host_wwpn import getAllHbaObjs



def execute(context):
    '''
    @summary:脚本入口
    @param context:上下文
    @param context: 有结果的上下文 
    '''
    hbaObjs = getAllHbaObjs(context)
    result  = getAllHbaDrVersions(hbaObjs)
    context.put('result',result)
    return context



def getAllHbaDrVersions(hbas):
    '''
    @summary: 获取驱动版本
    @param:hbas所有hba对象
    @return :驱动版本
    '''
    drVersions = ''
    for hba in hbas:
        if 'online' != hba.getState().lower():
            continue
        drVersions = drVersions + ';' + hba.getDrVersion()
    if not drVersions:
        drVersions = 'NA'
    else:
        drVersions = drVersions[1:]
    return drVersions


        