# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst = ["server_model","cpu_model","memory","os","multipath","cluster","lvm/vxvm","database"]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                value = get_value_bykey(tempList,key)
                value_lst.append(value)
    
    
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

 
#功能说明：返回Server model
def get_servermodel(tempList):
    result="NA"
    if len(tempList) == 4:
        tempArr = []
        tempArr = re.split("\\s+", tempList[2])
        if len(tempArr):
            result = tempArr[0]
            return result
        else:
            return result
    else:
        return result
    

#功能说明：返回CPU model    
def get_cpumodel(tempList):
    result="NA"
    #架构 厂商，位数
    arch = 'not found'
    vendor = 'not found'
    bit = 'not found'
    if checktempList(tempList):
        for i in range(len(tempList)):
            if 'uname -a' in tempList[i]:
                arch = tempList[i+1]
                break
        if 'x86_64' in arch:
            arch = re.split('\\s+',arch)[-2].strip()
            bit = '64'
        else:
            arch = re.split('\\s+',arch)[-2].strip()
            bit = '32'
        #求厂商
        for i,line in enumerate(tempList):
            if ('+pci' in line.lower()) and ('device' in line.lower()):
                tempList = tempList[i:]
                break
        for line in tempList:
            if ('vendor' in line.lower()) and ('name' in line.lower()):
                vendor = line.split('.')[-1].strip()
        result = arch+' '+vendor.upper()+bit
        return result
    else:
        return 'NA'


#功能说明：返回Memory
def get_memory(tempList):
    if 0==len(tempList):
        return 'NA'
    result="NA"
    count=0
    memFloat=0.0
    intv=0
    try:
        for i in range(len(tempList)):
            if "Physical Mem" in tempList[i] or "PhysicalMem" in tempList[i]:
                result=tempList[i]
                break
        for i in range(len(result)):
            if "." == result[i]:
                count=count+1
    except:
        pass
    result=result.replace(".","",count)
    result=result.replace("Physical", "")
    result=result.replace("Mem","")
    result=result.replace("|----","").strip()
    result=result.replace("bytes","").strip()
    intv=int(result)
    memFloat=float(intv)
    memFloat=memFloat/1024.0/1024.0/1024.0
    memFloat=round(memFloat,2)
    result=str(memFloat)+" "+"GB"
    return result

#功能说明：返回多路径名字
def get_multipath(tempList):
    multipath_name = 'NA'
    if 0 == len(tempList):
        return multipath_name
    
    txtList = []
    index = 0
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i])
            index = i + 1
    
    failStr = fail_flag
    
    resultTxt = []
    
    for txtBlock in txtList:
        flag = True
        for line in txtBlock:
            if failStr.lower() in line.lower():
                flag = False
                break
        if flag:
            resultTxt = txtBlock
            
    if len(resultTxt) == 0:
        return multipath_name
    
    for line in resultTxt:
        if ('ultrapath' in line):
            multipath_name = 'UltraPath'
        elif ('powerpath' in line):
            multipath_name = 'PowerPaht'
        elif ('hdlm'  in line):
            multipath_name = 'HDLM'
            
    return multipath_name
    
    
def get_cluster(tempList):
    result = "NA"
    if 0==len(tempList):
        return 'NA'
    result = '\\n'.join(tempList[1:-1])
    return result 
    
    
#功能说明：返回lvm/vxvm
def get_lvm(tempList):
    result = ""
    if 0==len(tempList):
        return 'NA'
    
    for i,value in enumerate(tempList):
        if ('lvm' in value.lower()) and ('version:' in value.lower()):
            result = tempList[i]
            break
    result = result.split(':')[1].strip()
    if ""!= result.lower():
        return result
    result = '\\n'.join(tempList[1:-1])
    return result 
    
#功能说明：返回数据库信息
def get_database(tempList):
    result = ""
    if 0==len(tempList):
        return 'NA'
    else:
        result = '\\n'.join(tempList[1:-1])
    return result 


#功能说明：返回操作系统
def get_os(tempList):
    result=""
    if 0==len(tempList):
        return 'NA'
    for i in range(len(tempList)):
        if "VMware".lower() in tempList[i].lower():
            result=tempList[i]
    return result
    
    
def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    elif key == key_lst[1]:
        return get_cpumodel(tempList)
    elif key == key_lst[2]:
        return get_memory(tempList)
    elif key == key_lst[3]:
        return get_os(tempList)
    elif key == key_lst[4]:
        return get_multipath(tempList)
    elif key == key_lst[5]:
        return get_cluster(tempList)
    elif key == key_lst[6]:
        return get_lvm(tempList)
    elif key == key_lst[7]:
        return get_database(tempList)
    else:
        return "Key Error"
    
