# --*-- coding:utf-8 --*--


#获取多路径运行参数
import sys
import os
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import getCommandRetFromTxt 


def execute(context):
    tempList = getCommandRetFromTxt(context)
    result = extractInfo(tempList)
    context.put("result", result)
    return context


#处理关键信息列表提取字段
def extractInfo(tempList):
    temp="\n"
    lst_a=[e for e in tempList if (("Device Display Name:" in e) or ("Storage Array Type:" in e) or ("Path Selection Policy:" in e))]
    temp=temp.join(lst_a)
    if len(temp.strip())>0:
        return temp
    else:
        return "no mutipathRunParams info"