# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                'mapping_view_id','mapping_view_name','host_group_id','host_group_name','host_id','host_name','host_type','initiator_wwn','port'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dicv2(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
   
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #由sg求 storagename & id & hba_lst 之对象集合
    storage_group_lst = []
    if (len(key_lst)==len(attribute_arr)):
        storage_key = attribute_arr[-2]
        storage_group_lst = attr_valuelst_dic[storage_key]
        
        #1.求Storage_Group_Entity 命令是：cmd_display_storage_group_sg
        storage_group_lst = get_storage_group_lst(storage_group_lst) 
    else:
        raise Exception("key Error,please check the Excel model's commands..")
    #由hba求hba之uid &ServerName即host_name
    
    #2.求hba_server，命令是：cmd_display_storage_group_hba
    hba_server_lst = []
    if (len(key_lst)==len(attribute_arr)):
        hba_key = attribute_arr[-4]
        hba_value_lst = attr_valuelst_dic[hba_key]
        
        hba_server_lst = get_hbaServer_lst(hba_value_lst)
    else:
        raise Exception("key Error,please check the Excel model's commands..")
    #获取传入的mapping_view_id
    mapping_view_id = attrcom_dic['mapping_view_id'][0].strip()
    #3.mapping_view_id就是Storage_Group_Entity之group_uid
    #获取mapping_view_name /hba_lst
    hba_lst = []
    portlst = []
    mapping_view_name = 'NA'
    for storage_group in storage_group_lst:
        if mapping_view_id in storage_group.get_uid():
            mapping_view_name = storage_group.get_name()
            hba_lst = storage_group.get_lst()
            portlst = storage_group.get_portlst()
            break
    #hba ->value_lst
    if 0 < len(hba_lst):
        for portidx ,hba_wwn in enumerate(hba_lst):
            value_lst.append('NA')
            value_lst.append(mapping_view_name)
            value_lst.append('NA')
            value_lst.append('NA')
            value_lst.append('NA')
            #根据hba uid查询host name
            host_name = 'NA'
            for hba_egg in hba_server_lst:
                if hba_wwn in  hba_egg.get_uid():
                    host_name = hba_egg.get_hostname()
                    break
            value_lst.append(host_name)
            value_lst.append('NA')
            value_lst.append(hba_wwn)
           #
            value_lst.append(portlst[portidx])
    else:
        value_lst.append('NA')
        value_lst.append(mapping_view_name)
        value_lst.append('NA')
        value_lst.append('NA')
        
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append('NA')
        #
        value_lst.append("NA")
        
    
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context



#获取storage group 对象集合
def get_storage_group_lst(temp_lst):
    storage_gp_bean = Storage_Group_Entity()
    storage_lst = []
    hba_start = 0
    if (None == temp_lst) or (0 == len(temp_lst)):
        storage_lst.append(storage_gp_bean)
        return storage_lst
    for i,line in enumerate(temp_lst):
        if ('storage' in line.lower()) and ('group' in line.lower()) and ('name' in line.lower()):
            storage_gp_bean = Storage_Group_Entity()
            name = line.split(':')[-1].strip()
            storage_gp_bean.set_name(name)
            continue
        elif ('storage' in line.lower()) and ('group' in line.lower()) and ('uid' in line.lower()):
            id_templst = re.split('\\s+',line.strip())
            id = id_templst[-1].strip()
            storage_gp_bean.set_id(id)
            storage_lst.append(storage_gp_bean)
            continue
        elif ('hba' in line.lower()) and ('uid' in line.lower()):
            hba_start = i+2
            hba_id_lst = temp_lst[hba_start:]
            id_lst = []
            portlst = []
            for id in hba_id_lst:
                if id.count(':')>3:
                    id = id.strip()
                    lst = re.split('\s\s+',id)
                    if len(lst) >= 2:
                        id_value = lst[0].strip()
                        id_lst.append(id_value)
                        #lst['20:00:01:20:FA:52:8F:6C:10:00:00:90:FA:52:8F:6C', 'SP B', '7']
                        portlst.append((lst[1].strip()+lst[-1]).replace(' ',''))
                else:
                    storage_gp_bean.set_lst(id_lst)
                    storage_gp_bean.set_portlst(portlst)
                    break
    return storage_lst
        

#获取hba对象集合
def get_hbaServer_lst(temp_lst):
    hba_server = Hba_Server_Entity()
    hba_lst = []
    if (None == temp_lst) or (0 == len(temp_lst)):
        return hba_lst
    for i,line in enumerate(temp_lst):
        if ('hba' in line.lower()) and ('uid' in line.lower()):
            hba_server = Hba_Server_Entity()
            id_temp_lst = re.split('\\s+',line)
            uid = id_temp_lst[-1]
            uid = uid.strip()
            hba_server.set_uid(uid)
            name_idx = i + 1
            name_temp = temp_lst[name_idx]
            
            name = name_temp.split(':')[-1].strip()
            hba_server.set_hostname(name)
            hba_lst.append(hba_server)
    return hba_lst
     

#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#attrcom_dic , {} #属性名:[命令1,命令2...]
#功能说明：attrcom_dic
def get_attrcom_dicv2(context):
    command = getValueFMap(context,style,'command')
    #去除最后面的';'
    if ';' == command.strip()[-1]:
        command = command[0:-1]
    attrcom_dic= {}
    try:
        for comd in command.split(';'):
            if comd.count(':')==1:
                lst = comd.split(':')
                key = lst[0].strip()
                if (1 < len(lst))and (',' in lst[1]):
                    addValueToMap(attrcom_dic, style, key, lst[1].strip().split(','))
                else:
                    addValueToMap(attrcom_dic, style, key, [lst[1].strip()])
            else:
                value_lst = comd.split(':')
                key = value_lst[0].strip()
                rep = key+':'
                value = comd.replace(rep,'')
                value = value.strip()
                addValueToMap(attrcom_dic, style, key,[value])
    except:
        raise Exception("Not Leagal ,this commands..")
    return attrcom_dic


class Storage_Group_Entity:
    __group_name = 'NA'
    __group_uid = 'NA'
    __hbaid_lst = []
    __port_lst = []
    
    def get_name(self):
        return self.__group_name
    def get_uid(self):
        return self.__group_uid
    def get_lst(self):
        return self.__hbaid_lst
    def get_portlst(self):
        return self.__port_lst
    
    def set_name(self,name):
        self.__group_name = name
    def set_id(self,id):
        self.__group_uid = id
    def set_lst(self,lst):
        self.__hbaid_lst = lst
    def set_portlst(self,lst):
        self.__port_lst= lst

class Hba_Server_Entity:
    __hba_uid = 'NA'
    __host_name = 'NA'
    def get_uid(self):
        return self.__hba_uid
    def get_hostname(self):
        return self.__host_name
    def set_uid(self,id):
        self.__hba_uid = id
    def set_hostname(self,name):
        self.__host_name = name
        
