# --*-- coding:utf-8 --*--

divide = "*********^^^^^^^^^^************^^^^^^^^^^*********"
fileList = None
command = None


#获取主机名
def execute(context):
    global fileList
    global command
    firstSpaceIndex=None
    firstNumIndex=None
    pathstr=None
    cpu_nums=0
    
    command = context.get("command")
    pathstr = context.get("path")
    
    fileList=getTxtReportList(pathstr);
    dict = getCommandStartEndIndex(command)
    startIndex = dict["start"]
    endIndex = dict["end"]
    tempList = fileList[startIndex:endIndex + 1]
    
    context.put("result",extractInfo(tempList))
    return context
    
def extractInfo(callList):
    callvalue = ""
    for call in callList :
        if not(":" in call) :
            continue
        callArr = call.split(":")
        if len(callArr) < 2 :
            continue
        if "Fabric OS" == callArr[0].strip() :
            callvalue = callArr[1].strip()
    if 0 == len(callvalue) :
        return ""
    
    return callvalue

#获取设备型号:Linux
def getEquipType():
    osList=getTxtReportList()
    osList=osList[2:3]
    osName=osList[0]
    return "Linux"
    
#获取Txt报告列表
def getTxtReportList(pathStr):
    fileHandle = open(pathStr, 'r');
    listtemp = fileHandle.readlines()
    fileHandle.close()
    return listtemp
    

#获取某命令的开始和结束索引
def getCommandStartEndIndex(command):
    start = 0
    end = 0
    for i in range(len(fileList)):
        if command.strip().lower() in fileList[i].strip().lower():
            start = i + 2
    for j in range(start, len(fileList)):
        if divide.strip().lower() in fileList[j].strip().lower():
            end = j - 1
            break
    return {"start":start, "end":end}     
      
